package matrixPower;
import matrixPower.gui.Gui;

/* Program na vypocet mocniny matice */
/* Hlavni trida, spusteni GUI a propojeni s funkcnosti */
public class Main {

    static Gui gui;    
    
    public static void main(String[] args) {
        Gui.main();     // vytvoreni GUI
    }
    
    public static void setGui(Gui actGui){
        gui = actGui;
    }
    
    
    /* vypis textu do vystupu v GUI */
    public static void addText(String nextText){
        gui.addOutText(nextText + "\n");
    }    
        
     
    /* vypocet mocniny matice (paralelne i neparalelne) */
    public static boolean work(Matrix matrix, int power, int nproc, int workSize){
        boolean result;
        long startTime, endTime;        /* promenne pro mereni casu */
        Matrix resultSimple;            /* vysledna mocnina pocitana bez paralelizace */
        Matrix resultThread;            /* vysledna mocnina pocitana vlakny */
        
        MatrixHandler handler = new MatrixHandler();    /* pocita kontrolni mocninu */
        
        /* kontrolni vypocet bez paralelizace */
	startTime = System.nanoTime();
	resultSimple = handler.power(matrix, power);    /* vypocet kontrolni mocniny */
	endTime = System.nanoTime();
	addText("Vypocet bez paralelizace:\n");
	addText("Execution time: " + (Double.toString((endTime - startTime)/(double)1000000)) + " ms");
	addText("-----------------------------------");
	addText(resultSimple.toString());
	addText("===================================");
	addText("Vypocet s paralelizaci:");
	addText("-----------------------------------");
	
        /* vytvoreni instance farmer */
	PowerMonitor monitor = new PowerMonitor(nproc, workSize, power);

	startTime = System.nanoTime();
	resultThread = monitor.power (matrix);  /* vypocet mocniny s vlakny */
	endTime = System.nanoTime();
	addText("Execution time: " + (Double.toString((endTime - startTime)/(double)1000000)) + " ms");
	addText("-----------------------------------");
	addText("Result = ");
	addText(resultThread.toString());
	addText("-----------------------------------");
		
        /* kontrola vysledku */
	if (resultThread.equals(resultSimple)){
            addText("Vysledek OK");
            result = true;
	}
	else {
            addText("MATICE NESHODNE");
            result = false;
	}
		    
        /* ukonceni workeru */
	addText("End of work: code " + monitor.stop());        
        return result;
    }   
	
}
