package matrixPower;

/* Trida matice */
public class Matrix {

	private int[][] matrix; /* hodnoty prvku matice */
	private int grade;      /* stupen matice */
	
	public Matrix(int grade){
		this.setGrade(grade);
		matrix = new int[grade][grade];
	}
	
	public void set(int i, int j, int value){
		matrix[i][j] = value;
	}
	
	public void set(Coordinate cord){
		matrix[cord.getRow()][cord.getColumn()] = cord.getValue();
	}
	
	public int get(int i, int j){
		return matrix[i][j];
	}
	
        @Override
	public String toString(){
		String result = "";
		for (int i = 0; i < this.getGrade(); i++){
			for (int j = 0; j < this.getGrade(); j++){
				result += this.get(i, j) + "\t";
			}
			result += "\n";
		}
		return result;
	}
	
        @Override
	public boolean equals(Object o){
		
		if (this.getClass() != o.getClass()){
			return false;
		}
		for (int i = 0; i < grade; i++){
			for (int j = 0; j < grade; j++){
				if (this.get(i, j) != ((Matrix) o).get(i, j)){
					return false;
				}
			}
		}
		
		return true;
		
	}

	public void setGrade(int grade) {
		this.grade = grade;
	}

	public int getGrade() {
		return grade;
	}
}
