package matrixPower;

import matrixPower.gui.Gui;
import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

/* ErrorHandler pro nacitani matice z XML souboru 
 * 
 * zpravy vypisuje bud do konsole nebo do GUI 
 * 
 */

public class MyErrorHandler implements ErrorHandler{
    
        private Gui gui;
        
        public MyErrorHandler(){
            gui = null;
        }
        
        public MyErrorHandler(Gui gui){
            this.gui = gui;
        }

	private String text(SAXParseException e){
		return e.getSystemId()+"\n"+"line: "+e.getLineNumber()+" column: "+e.getColumnNumber()+"\n"+e.getMessage();
	}
	
	public void warning(SAXParseException e) {
                if (gui == null){
                    System.out.println("Warning: "+text(e));
                }
                else {
                    gui.showMessage(text(e));
                }
		
	}
	public void error(SAXParseException e) throws SAXException {
                if (gui == null){
                    System.out.println("Error: "+text(e));
                    end();
                }
                else {
                    gui.showMessage(text(e));
                }		
	}
	public void fatalError(SAXParseException e)throws SAXException {
            if (gui == null){
                System.out.println("Fatal error: "+text(e));
		end();
            }
            else {
                gui.showMessage(text(e));
            }		
	}
	
	private void end(){
		System.out.println("The input data is not correct.");
		System.exit(0);
	}
}