package matrixPower.gui;

import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import matrixPower.Main;
import matrixPower.Matrix;
import matrixPower.MatrixReader;

/* GUI pro vypocet k-te mocniny matice */
public class Gui extends javax.swing.JFrame {
    
    private int power = 3, workSize = 4, workersCnt = 4;
    private Matrix matrix = null;   
    private MatrixReader reader;
    private JFileChooser fileChooser;
    
    public Gui() {
        initComponents();
        reader = new MatrixReader(this);
        matrixTA.setTabSize(3);
        outTA.setTabSize(5);
        this.setSystemLookAndFeel();
        this.setLocationRelativeTo(null);
        this.setVisible(true);
        Main.setGui(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        powerED = new javax.swing.JTextField();
        workersED = new javax.swing.JTextField();
        jLabel11 = new javax.swing.JLabel();
        workSizeED = new javax.swing.JTextField();
        optimiseWorkSizeCHB = new javax.swing.JCheckBox();
        jPanel2 = new javax.swing.JPanel();
        jScrollPane2 = new javax.swing.JScrollPane();
        outTA = new javax.swing.JTextArea();
        jPanel3 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        matrixTA = new javax.swing.JTextArea();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Výpočet mocniny matice");

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Nastavení"));

        jLabel1.setText("Mocnina:");

        jLabel2.setText("Počet dělníků:");

        powerED.setText("3");

        workersED.setText("4");

        jLabel11.setText("Velikost práce:");

        workSizeED.setText("4");

        optimiseWorkSizeCHB.setSelected(true);
        optimiseWorkSizeCHB.setText("Optimalizovat velikost práce");
        optimiseWorkSizeCHB.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                optimiseWorkSizeCHBActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel1Layout.createSequentialGroup()
                        .addContainerGap()
                        .add(optimiseWorkSizeCHB))
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(20, 20, 20)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(jLabel11)
                            .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                                .add(jLabel2)
                                .add(jLabel1)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                            .add(workSizeED)
                            .add(workersED)
                            .add(jPanel1Layout.createSequentialGroup()
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(powerED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 41, Short.MAX_VALUE)))))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(powerED, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(workersED, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel11)
                    .add(workSizeED, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 5, Short.MAX_VALUE)
                .add(optimiseWorkSizeCHB)
                .addContainerGap())
        );

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("Výstup"));

        outTA.setColumns(20);
        outTA.setEditable(false);
        outTA.setRows(5);
        jScrollPane2.setViewportView(outTA);

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 468, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .add(jScrollPane2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 341, Short.MAX_VALUE)
                .addContainerGap())
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Matice"));

        matrixTA.setColumns(20);
        matrixTA.setEditable(false);
        matrixTA.setRows(5);
        jScrollPane1.setViewportView(matrixTA);

        jButton3.setText("Výběr vstupu");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                selectMatrix(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 10, Short.MAX_VALUE)
                .add(jButton3)
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 107, Short.MAX_VALUE)
                    .add(jButton3))
                .addContainerGap())
        );

        jButton4.setText("Spustit výpočet");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                work(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.UNRELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(jButton4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 185, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 122, Short.MAX_VALUE))
                            .add(jPanel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jButton4)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        jPanel1.getAccessibleContext().setAccessibleName("Nastaveni");

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /* kontrola spravnosti zadanych udaju */
    private boolean checkInputs(){
        try {
            power = Integer.parseInt(powerED.getText());
            workSize = Integer.parseInt(workSizeED.getText());
            workersCnt = Integer.parseInt(workersED.getText());
            
            if (power < 2){
                String text = "Prilis mala mocnina. (" + power + ")";
                text += "\n" + "Zadejte cislo >= 2.";
                JOptionPane.showMessageDialog(this, text);
	    	return false;
	    }
            if (workersCnt < 1){
                String text = "Nespravny pocet delniku. (" + workersCnt + ")";
                text += "Zadejte cislo >= 1.";
                JOptionPane.showMessageDialog(this, text);
	    	return false;
            }
            if (workSize < 1){
                String text = "Nespravne zadana jednotka prace (" + workSize + ").";
                text += "Zadejte cislo >= 1.";
                JOptionPane.showMessageDialog(this, text);
	    	return false;
            }
            if (matrix == null){
                String text = "Vyberte vstupni matici.";
                JOptionPane.showMessageDialog(this, text);
	    	return false;
            }
            
        }
        catch (NumberFormatException e){
            JOptionPane.showMessageDialog(this, "Spatny format cisla.");
            return false;
        }       
        return true;
    }
    
    /* vypocet mocniny */
    private void work(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_work
        if (checkInputs()){            
            
            outTA.setText("");
            
            /* kontrola smysluplnosti velikosti prace */
            
            if (optimiseWorkSizeCHB.isSelected()){
                if (workSize * workersCnt > matrix.getGrade() * matrix.getGrade()){
                    workSize = matrix.getGrade() * matrix.getGrade() / workersCnt;
                    if (workSize == 0){
                        workSize = 1;
                    }
                
                    JOptionPane.showMessageDialog(this, "Uprava velikosti prace kvuli vyssi efektivite.");
                    workSizeED.setText(String.valueOf(workSize));
                } 
            }            
            
            if (Main.work(matrix, power, workersCnt, workSize)){
                JOptionPane.showMessageDialog(this, "Vypocet OK");
            }
            else {
                JOptionPane.showMessageDialog(this, "Vypocet neprobehl spravne.");
            }
        }
        
}//GEN-LAST:event_work

    /* pridani textu do vystupu vypoctu */
    public void addOutText(String text){
        outTA.append(text);
    }
    
    /* zobrazeni zpravy */
    public void showMessage(String text){
        JOptionPane.showMessageDialog(this, text);
        matrixTA.setText("");
    }
    
    private void selectMatrix(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_selectMatrix
        // TODO add your handling code here:
       selectMatrix();
    }//GEN-LAST:event_selectMatrix

    private void optimiseWorkSizeCHBActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_optimiseWorkSizeCHBActionPerformed
        // TODO add your handling code here:
}//GEN-LAST:event_optimiseWorkSizeCHBActionPerformed
    
    /* vyber XML souboru s matici */
    private void selectMatrix(){
        fileChooser = new JFileChooser(".");
	fileChooser.showOpenDialog(this);
	if (fileChooser.getSelectedFile() == null){
            return;
	}
        File file = fileChooser.getSelectedFile();
        try {
            matrix = reader.loadXML(file);
            matrixTA.setText(matrix.toString());
        }
        catch (Exception e){
            matrix = null;
            String text = "Matici se nepodarilo nacist.";
            text += "\n" + e.getMessage();
            JOptionPane.showMessageDialog(this, text);
        }
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main() {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                Gui gui = new Gui();
                
            }
        });
    }
    
    private void setSystemLookAndFeel(){
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        }
        catch (ClassNotFoundException e){
            e.printStackTrace();
        }
        catch (InstantiationException e){
            e.printStackTrace();
        }
        catch (IllegalAccessException e){
            e.printStackTrace();
        }
        catch (UnsupportedLookAndFeelException e){
            e.printStackTrace();
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextArea matrixTA;
    private javax.swing.JCheckBox optimiseWorkSizeCHB;
    private javax.swing.JTextArea outTA;
    private javax.swing.JTextField powerED;
    private javax.swing.JTextField workSizeED;
    private javax.swing.JTextField workersED;
    // End of variables declaration//GEN-END:variables
    
}
